#!/usr/bin/env python

# Convert old Gin config files into new-style ones.
#
# Things we need to do:
#  - Remove any type information from column mappings
#  - Change 'primarykey' to 'column'
#  - Change multivalued attributes to use new linked table syntax

import sys

if len(sys.argv) != 2:
    sys.stderr.write("Usage: rgma-gin-convert.py <original>\n")
    sys.exit(1)

file = open(sys.argv[1], "r")
lines = file.readlines()
file.close()
inTable = 0

for line in lines:
    text = line.strip().lower()
    if text.startswith("column") or \
       text.startswith("primarykey") or \
       text.startswith("multivalued"):
       startType = line.find(":")
       if startType >= 0:
         endType = startType + line[startType:].find(" ")
         firstPart = line[:startType]
         secondPart = line[endType:]
         if firstPart.strip() in ("column", "primarykey", "multivalued"):
           line = firstPart + secondPart
    if text.startswith("primarykey"):
        line = "    column" + line.strip()[len("primarykey"):] + "\n"
    if text.startswith("table"):
        inTable += 1
    if text.startswith("endtable"):
        inTable -= 1
    if text.startswith("multivalued"):
        if inTable == 1:
          parts = line.split()
          for part in parts:
              split = part.split("=")
              table = split[0]
              if len(split) == 2:
                  attribute = split[1]
              else:
                  attribute = table
          line = "    table %s\n      multivalued Value=%s\n    endtable\n" % (table, attribute)
        else:
          ## This is already a new-style config file
          pass
          
    sys.stdout.write(line)
